Public Class PlanetaryWeather

    'The line preceding function declaration asserts that this function needs to have FullTrust rights 
    ' even though it is called by a process that only has Execution rights.
    '
    'Also, the following line is required in AssemblyInfo.vb in order for the assert to work:
    '
    ' <Assembly: Security.AllowPartiallyTrustedCallers()> 

    <System.Security.Permissions.PermissionSetAttribute(System.Security.Permissions.SecurityAction.Assert, Name:="FullTrust")> _
    Public Shared Function GetWeather(ByVal Abbrv As String) As String
        Dim cs As com.capescience.live.AirportWeather
        Dim abbrvToUse As String
        Dim result As String
        Dim startPos As Integer
        Dim endPos As Integer
        Dim weatherReport As String

        cs = New com.capescience.live.AirportWeather

        ' Substitute airport abbreviations for planet abbreviations
        If Abbrv = "AFU" Then
            abbrvToUse = "HECA"
        ElseIf Abbrv = "BLN" Then
            abbrvToUse = "RJTT"
        ElseIf Abbrv = "NOX" Then
            abbrvToUse = "YSSY"
        ElseIf Abbrv = "RKM" Then
            abbrvToUse = "EGLL"
        ElseIf Abbrv = "SLN" Then
            abbrvToUse = "KLAX"
        Else
            abbrvToUse = "VHHH"
        End If

        ' Get the temperature
        result = cs.getTemperature(abbrvToUse)

        ' Remove everything except for the temp in Celcius
        startPos = InStr(result, "(")
        endPos = InStr(result, ")")

        weatherReport = "Temperature: " & Mid(result, startPos + 1, endPos - startPos - 1)

        ' Get the sky conditions
        result = cs.getSkyConditions(abbrvToUse)

        ' Remove everything except for the sky conditions
        startPos = InStr(result, "is")

        weatherReport = weatherReport & "   Sky Conditions: " & Mid(result, startPos + 2, 500)

        ' Get the wind conditions
        result = cs.getWind(abbrvToUse)

        ' Find the wind direction
        startPos = InStr(result, "from the")
        endPos = InStr(result, ")")

        weatherReport = weatherReport & "   Wind Conditions: " & Mid(result, startPos + 9, endPos - startPos - 8)

        result = Mid(result, endPos + 1, 500)

        ' Find the wind speed in KT
        startPos = InStr(result, "(")
        endPos = InStr(result, ")")

        weatherReport = weatherReport & " at: " & Mid(result, startPos + 1, endPos - startPos - 1)

        GetWeather = weatherReport
    End Function
End Class
